<?php

namespace EnumType;

/**
 * This class stands for StatusNameType EnumType
 * @subpackage Enumerations
 */
class StatusNameType
{
    /**
     * Constant for value 'Error'
     * @return string 'Error'
     */
    const VALUE_ERROR = 'Error';
    /**
     * Constant for value 'Pending'
     * @return string 'Pending'
     */
    const VALUE_PENDING = 'Pending';
    /**
     * Constant for value 'Cancelled'
     * @return string 'Cancelled'
     */
    const VALUE_CANCELLED = 'Cancelled';
    /**
     * Constant for value 'Completed'
     * @return string 'Completed'
     */
    const VALUE_COMPLETED = 'Completed';
    /**
     * Constant for value 'RiskRejected'
     * @return string 'RiskRejected'
     */
    const VALUE_RISK_REJECTED = 'RiskRejected';
    /**
     * Constant for value 'ValidationError'
     * @return string 'ValidationError'
     */
    const VALUE_VALIDATION_ERROR = 'ValidationError';
    /**
     * Constant for value 'WebRedirectRequired'
     * @return string 'WebRedirectRequired'
     */
    const VALUE_WEB_REDIRECT_REQUIRED = 'WebRedirectRequired';
    /**
     * Constant for value 'ThreeDSecureRedirectRequired'
     * @return string 'ThreeDSecureRedirectRequired'
     */
    const VALUE_THREE_DSECURE_REDIRECT_REQUIRED = 'ThreeDSecureRedirectRequired';
    /**
     * Constant for value 'VaultFailure'
     * @return string 'VaultFailure'
     */
    const VALUE_VAULT_FAILURE = 'VaultFailure';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_ERROR
     * @uses self::VALUE_PENDING
     * @uses self::VALUE_CANCELLED
     * @uses self::VALUE_COMPLETED
     * @uses self::VALUE_RISK_REJECTED
     * @uses self::VALUE_VALIDATION_ERROR
     * @uses self::VALUE_WEB_REDIRECT_REQUIRED
     * @uses self::VALUE_THREE_DSECURE_REDIRECT_REQUIRED
     * @uses self::VALUE_VAULT_FAILURE
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_ERROR,
            self::VALUE_PENDING,
            self::VALUE_CANCELLED,
            self::VALUE_COMPLETED,
            self::VALUE_RISK_REJECTED,
            self::VALUE_VALIDATION_ERROR,
            self::VALUE_WEB_REDIRECT_REQUIRED,
            self::VALUE_THREE_DSECURE_REDIRECT_REQUIRED,
            self::VALUE_VAULT_FAILURE,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
